/**
 * Sistemas de Telecomunicacoes 2014/2015
 *
 * Daemon_tcp.java
 *
 * Thread class that handles the acceptation of new connection on the server
 * socket
 *
 * Created on March 22, 2015, 18:00
 *
 * @author Luis Bernardo
 */
package proxy;

import java.net.ServerSocket;

class Daemon_tcp extends Thread {

    /**
     * GUI object
     */
    ProxyHttpd root;
    /**
     * Server socket object
     */
    ServerSocket ss;
    /**
     * Active flag
     */
    volatile boolean active;

    /**
     * Constructor
     *
     * @param root GUI object
     * @param ss server socket
     */
    Daemon_tcp(ProxyHttpd root, ServerSocket ss) {
        this.root = root;
        this.ss = ss;
    }

    /**
     * Interrupt the thread
     */
    public void wake_up() {
        this.interrupt();
    }

    /**
     * Stop the thread
     */
    public void stop_thread() {
        active = false;
        this.interrupt();
    }

    /**
     *
     */
    @Override
    public void run() {
        System.out.println(
                "\n******************** " + ProxyHttpd.server_name + " started ********************\n");
        active = true;
        while (active) {
            try {
                PHttpThread conn
                        = new PHttpThread(root, ss, ss.accept());
                conn.start();
            } catch (java.io.IOException e) {
                if (active) {
                    root.Log("IO exception: " + e + "\n");
                }
                active = false;
            }
        }
    }
} // end of class Daemon_tcp
