/**
 * Sistemas de Telecomunicacoes 2014/2015
 *
 * ServHttpd.java
 *
 * Main class with graphical interface and server control logic
 *
 * Created on March 22, 2015, 18:00
 *
 * @author Luis Bernardo
 */
package proxy;

import java.io.DataInputStream;
import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.SocketException;
import java.net.UnknownHostException;
import java.util.HashMap;
import javax.swing.JTextField;

public class ProxyHttpd extends javax.swing.JFrame {

    /**
     * Server name - EXERCISE: Replace the 00000 by your numbers
     */
    public final static String server_name = "HTTP Proxy 2014/2015 by 00000/00000/00000";
    /**
     * Default file name when browser sends "/"
     */
    public final static String HOMEFILENAME = "index.htm";
    /**
     * Accepts up to 10 pending TCP connections
     */
    final static int MaxAcceptLog = 10;
    /**
     *
     */
    private Daemon_tcp main_thread = null;
    /**
     * UDP thread used to receive REGIST messages
     */
    private Daemon_udp udp_thread = null;
    /**
     * Server socket where new connections are accepted
     */
    private ServerSocket sTCPsock;
    /**
     * Datagram socket to receive REGIST packets
     */
    private DatagramSocket UDPsock;
    /**
     * List with all server registrations
     */
    private final HashMap<String, ServerInfo> servers = new HashMap<String, ServerInfo>();
    /**
     * Auxiliary formatter variable, to format dates to hour:minutes:seconds
     */
    private final java.text.SimpleDateFormat formatter = // Formatter for dates
            new java.text.SimpleDateFormat("hh:mm:ss");

    /**
     * Consctructor - creates a new form
     */
    public ProxyHttpd() {
        initComponents();
        setTitle(server_name);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jToggleButtonActive = new javax.swing.JToggleButton();
        jLabel5 = new javax.swing.JLabel();
        jTextIP = new javax.swing.JTextField();
        jPanel2 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        jTextTCPport = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jTextUDPport = new javax.swing.JTextField();
        jButtonClear = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();

        setTitle("Proxy HTTP ST 2014/2015 by ?????/?????/?????");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        getContentPane().setLayout(new javax.swing.BoxLayout(getContentPane(), javax.swing.BoxLayout.Y_AXIS));

        jPanel1.setMaximumSize(new java.awt.Dimension(450, 35));
        jPanel1.setMinimumSize(new java.awt.Dimension(450, 35));
        jPanel1.setName("Estado"); // NOI18N
        jPanel1.setPreferredSize(new java.awt.Dimension(450, 35));

        jToggleButtonActive.setText("Active");
        jToggleButtonActive.setMaximumSize(new java.awt.Dimension(85, 29));
        jToggleButtonActive.setPreferredSize(new java.awt.Dimension(85, 29));
        jToggleButtonActive.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jToggleButtonActiveActionPerformed(evt);
            }
        });
        jPanel1.add(jToggleButtonActive);

        jLabel5.setText("IP");
        jPanel1.add(jLabel5);

        jTextIP.setEditable(false);
        jTextIP.setPreferredSize(new java.awt.Dimension(200, 20));
        jPanel1.add(jTextIP);

        getContentPane().add(jPanel1);

        jPanel2.setToolTipText("configuração");
        jPanel2.setMaximumSize(new java.awt.Dimension(420, 35));
        jPanel2.setMinimumSize(new java.awt.Dimension(420, 35));
        jPanel2.setName("configuracao"); // NOI18N
        jPanel2.setPreferredSize(new java.awt.Dimension(420, 35));

        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        jLabel4.setText("TCP Port");
        jLabel4.setMaximumSize(new java.awt.Dimension(53, 17));
        jLabel4.setPreferredSize(new java.awt.Dimension(53, 17));
        jPanel2.add(jLabel4);

        jTextTCPport.setText("20000");
        jPanel2.add(jTextTCPport);

        jLabel1.setText("UDP Port");
        jPanel2.add(jLabel1);

        jTextUDPport.setText("20000");
        jTextUDPport.setToolTipText("");
        jPanel2.add(jTextUDPport);

        jButtonClear.setText("Clear");
        jButtonClear.setMaximumSize(new java.awt.Dimension(75, 29));
        jButtonClear.setOpaque(true);
        jButtonClear.setPreferredSize(new java.awt.Dimension(75, 29));
        jButtonClear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonClearActionPerformed(evt);
            }
        });
        jPanel2.add(jButtonClear);

        getContentPane().add(jPanel2);

        jScrollPane2.setPreferredSize(new java.awt.Dimension(454, 104));

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null}
            },
            new String [] {
                "File", "Servers", "Time"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.Long.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane2.setViewportView(jTable1);

        getContentPane().add(jScrollPane2);

        jScrollPane1.setPreferredSize(new java.awt.Dimension(360, 180));

        jTextArea1.setLineWrap(true);
        jTextArea1.setPreferredSize(new java.awt.Dimension(200, 2000));
        jTextArea1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                jTextArea1KeyPressed(evt);
            }
        });
        jScrollPane1.setViewportView(jTextArea1);

        getContentPane().add(jScrollPane1);

        getAccessibleContext().setAccessibleName("HTTP GUI - RIT2 2011/2012 by ?????/?????/?????");

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Clear the text area
     */
    private void jButtonClearActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonClearActionPerformed
        jTextArea1.setText("");
    }//GEN-LAST:event_jButtonClearActionPerformed

    /**
     * Clear the text area
     */
    private void jTextArea1KeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jTextArea1KeyPressed
        if (evt.getKeyChar() == ' ') {
            jTextArea1.setText("");
        }
    }//GEN-LAST:event_jTextArea1KeyPressed

    /**
     * Handles the button that starts and stops the Proxy server
     */
    private void jToggleButtonActiveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jToggleButtonActiveActionPerformed
        if (jToggleButtonActive.isSelected()) {
            // Parse UI parameters            
            int tcpport, udpport;

            tcpport = getTCPPort();
            if (tcpport == 0) {
                Log("Invalid TCP port number\n");
                jToggleButtonActive.setSelected(false);
                return;
            }
            udpport = getUDPPort();
            if (udpport == 0) {
                Log("Invalid UDP port number\n");
                jToggleButtonActive.setSelected(false);
                return;
            }
            // Starts web sTCPsock
            try {
                sTCPsock = new ServerSocket(tcpport, MaxAcceptLog);
            } catch (java.io.IOException e) {
                Log("TCP socket creation failure: " + e + "\n");
                jToggleButtonActive.setSelected(false);
                return;
            }
            // Starts UDP socket and thread
            try {
                UDPsock = new DatagramSocket(udpport);    // Create UDP socket
                udp_thread = new Daemon_udp(this, UDPsock);  // Create the receiver thread
                udp_thread.start();                       // Start the receiver thread
            } catch (SocketException e) {
                Log("UDP socket creation failure: " + e + "\n");
                try {
                    sTCPsock.close();
                    sTCPsock = null;
                } catch (IOException ex) {
                    Log("Error closing TCP socket: " + e + "\n");
                }
                jToggleButtonActive.setSelected(false);     // Set the button off
            }

            // Gets local IP
            try {
                jTextIP.setText(InetAddress.getLocalHost().getHostAddress());
            } catch (UnknownHostException e) {
                Log("Failed to get local IP: " + e + "\n");
            }

            // starts TCP thread
            main_thread = new Daemon_tcp(this, sTCPsock);
            main_thread.start();

            setEditable_jText(false);
            Log("Proxy server active\n");
        } else {
            stop_all();

            setEditable_jText(true);
            Log("Proxy server stopped\n");
        }
    }//GEN-LAST:event_jToggleButtonActiveActionPerformed

    /**
     * Stop all sockets and threads
     */
    private void stop_all() {
        // Stop sTCPsock
        try {
            if (main_thread != null) {
                main_thread.stop_thread();
                main_thread = null;
            }
            if (sTCPsock != null) {
                sTCPsock.close();
                sTCPsock = null;
            }
        } catch (Exception e) {
            Log("Exception closing server socket: " + e + "\n");
        }
        // Stop UDPsock
        try {
            if (udp_thread != null) {
                udp_thread.stopRunning();
                udp_thread = null;
            }
            if (UDPsock != null) {
                UDPsock.close();
                UDPsock = null;
            }
        } catch (Exception e) {
            Log("Exception closing server socket: " + e + "\n");
        }
        jTextIP.setText("");

    }

    /**
     * Capture exit of the Application closing the graphical window
     */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm

    /**
     * Controls editability of jTexts
     *
     * @param editable if the user can change the boxes' contents
     */
    public void setEditable_jText(boolean editable) {
        jTextTCPport.setEditable(editable);
        jTextUDPport.setEditable(editable);
    }

    /**
     * Logs a message on the command line and on the text area
     *
     * @param s string to be written
     */
    public void Log(String s) {
        jTextArea1.append(s);
        System.out.print(s);
    }

    /**
     * Returns the port number in a JTextField
     */
    private int getPort(JTextField jt) {
        try {
            int port = Integer.parseInt(jt.getText());
            if ((port <= 0) || (port > 65535)) {
                return 0;
            }
            return port;
        } catch (NumberFormatException e) {
            return 0;
        }
    }

    /**
     * Returns the local TCP port number
     *
     * @return local TCP port number
     */
    public int getTCPPort() {
        return getPort(jTextTCPport);
    }

    /**
     * Returns the local UDP port number
     *
     * @return local UDP port number
     */
    public int getUDPPort() {
        return getPort(jTextUDPport);
    }

    /**
     * Returns true if main_thread is active
     *
     * @return
     */
    public boolean active() {
        return (main_thread != null);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new ProxyHttpd().setVisible(true);
    }

    /**
     * Method that handles the reception of datagram messages
     *
     * @param dp
     * @param dis
     */
    public synchronized void receive_packet(DatagramPacket dp,
            DataInputStream dis) {
        String from = dp.getAddress().getHostAddress() + ":" + dp.getPort();
        try {
            int type;  //message type
            String name= ""; // filename
            int port= 0;   // port number
            short number1= -1, number2= -1, number3= -1; // Student's numbers
            
            /*
             * EXERCISE: Place here the code to read the REGIST message contents
             *           using the dis object
             */
            Log("receive_packet incomplete - please implement it\n");
            type= dis.readShort();
            
            // Write message contents
            System.out.println("Received from " + from + " ("+number1+";"+
                    number2+";"+number3+") type "+type+" - '" + name + "(" + port + ")");
                        
            // Add registration to the list
            add_server(name, dp.getAddress(), port);

        } catch (IOException e) {
            Log("Packet too short from " + from + ":" + e + "\n");
        }
    }

    /**
     * Add server to list
     * @param name 
     * @param ip
     * @param port
     */
    public void add_server(String name, InetAddress ip, int port) {
        servers.put(name, new ServerInfo(name, ip, port));
        update_servers_window();
    }

    /**
     * Get server information from list
     * @param name
     * @return
     */
    public ServerInfo get_server(String name) {
        ServerInfo pt = servers.get(name);
        if ((pt == null) || !pt.valid()) {
            return null;
        }
        return pt;
    }

    /**
     * Clear the server window
     */
    private void clear_servers_window() {
        for (int r = 0; r < jTable1.getRowCount(); r++) {
            for (int c = 0; c < 3; c++) {
                jTable1.setValueAt("", r, c);
            }
        }
    }

    /**
     * Update the server window contents
     */
    public void remove_outdated_servers() {
        /**
         * EXERCISE: Put here the code to remove outdated registrations from the list
         */
        Log("remove_outdated_servers not implemented yet");
    }

    /**
     * Update the server window contents
     */
    public void update_servers_window() {
        clear_servers_window();
        int line = 0;
        for (ServerInfo pt : servers.values()) {
            if (pt.valid()) { // Only writes the valid entries
                jTable1.setValueAt(pt.name(), line, 0);
                jTable1.setValueAt(pt.toString(), line, 1);
                jTable1.setValueAt(formatter.format(pt.date()), line, 2);
                line++;
            } 
        }
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonClear;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTable jTable1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextField jTextIP;
    private javax.swing.JTextField jTextTCPport;
    private javax.swing.JTextField jTextUDPport;
    private javax.swing.JToggleButton jToggleButtonActive;
    // End of variables declaration//GEN-END:variables
}
